<template>
    <div :class="{'has-logo':showLogo}" :style="{ backgroundColor: settings.sideTheme === 'theme-dark' ? variables.menuBackground : variables.menuLightBackground }">
        <logo v-if="showLogo" :collapse="isCollapse" />
        <el-scrollbar :class="settings.sideTheme" wrap-class="scrollbar-wrapper">
            <el-menu
                :default-active="activeMenu"
                :collapse="isCollapse"
                :background-color="settings.sideTheme === 'theme-dark' ? variables.menuBackground : variables.menuLightBackground"
                :text-color="settings.sideTheme === 'theme-dark' ? variables.menuColor : variables.menuLightColor"
                :unique-opened="true"
                :active-text-color="settings.theme"
                :collapse-transition="false"
                mode="vertical"
                @select="handleMenuSelect"
            >
                <sidebar-item
                    v-for="(route, index) in sidebarRouters"
                    :key="route.path  + index"
                    :item="route"
                    :base-path="route.path"
                />
            </el-menu>
        </el-scrollbar>
    </div>
</template>

<script>
import { mapGetters, mapState } from "vuex"
import Logo from "./Logo"
import SidebarItem from "./SidebarItem"
import variables from "@/assets/styles/variables.scss"
import {clicMenuCount} from "@/api/menu";

export default {
    components: { SidebarItem, Logo },
    computed: {
        ...mapState(["settings"]),
        ...mapGetters(["sidebarRouters", "sidebar"]),
        activeMenu() {
            const route = this.$route
            const { meta, path } = route
            // if set path, the sidebar will highlight the path you set
            if (meta.activeMenu) {
                return meta.activeMenu
            }
            return path
        },
        showLogo() {
            return this.$store.state.settings.sidebarLogo
        },
        variables() {
            return variables
        },
        isCollapse() {
            return !this.sidebar.opened
        }
    },
    data(){
        return {
          menuList: {}
      }
    },
    created() {
      this.menuHandle(this.sidebarRouters);
    },
    methods: {
      // 点击菜单 计数
      handleMenuSelect(index, indexPath) {
        let params = {pageRoute: index, pageName: this.menuList[index]};
        clicMenuCount(params).then(res => {});
      },
      // 处理菜单
      menuHandle(menu) {
        menu.forEach(item => {
          if (!item.hidden) {
            item.children.forEach(val => {
              if (!val.hidden) {
                if (val.children) {
                  val.path = item.path + '/'  + val.path;
                  this.menuHandle([val]);
                } else {
                  let link = item.path && item.path === '/' ? item.path + val.path : item.path + '/' + val.path;
                  this.menuList[link] = val.meta.title;
                }
              }
            });
          }
        });
      },
      }
}
</script>
